import java.io.*;
import java.util.HashSet;
public final class StatCalc
{
   private StatCalc(){}
   
   public static void main(String[] args)
   {
      try
      {
         if (args.length < 10)
         {
            System.out.println("**Required Parameters**");
            System.out.println("1st:  The first level to print, inclusive");
            System.out.println("2rd:  The last level to print, inclusive");
            System.out.println("3th:  The first job to print, inclusive");
            System.out.println("4th:  The last job to print, inclusive");
            System.out.println("5th:  The gender you want generics to stat as: 0 for male, 1 for female, 2 for Ramza, 3 for monster");
            System.out.println("6th:  The first ability to print, inclusive");
            System.out.println("7th:  The last ability to print, inclusive");
            System.out.println("8th:  Brave");
            System.out.println("9th:  Caster Faith");
            System.out.println("10th: Target Faith");
            System.out.println("11th: Weapon dmg type");
            System.out.println("\t0 - PA * WP - Sword, Rod, Spear, Crossbow");
            System.out.println("\t1 - MA * WP - Staff, Stick");
            System.out.println("\t2 - WP * WP - Gun");
            System.out.println("\t3 - PA * PA * Brave / 100 - Fist, Knight Sword, Katana");
            System.out.println("\t4 - (PA + SP) / 2 * WP - Knife, Ninja Knife, Bow");
            System.out.println("\t5 - (PA + MA) / 2 * WP - Cloth, Harp, Book");
            System.out.println("\t6 - (1..PA) * WP - Flail, Axe, Bag");
            System.out.println("12th: WP");
         }
         else
         {
            //put job names and ids into an array
            BufferedReader jobNameReader = new BufferedReader(new FileReader("jobNames.csv"));
            String[][] jobNames = new String[160][3];
            String line = jobNameReader.readLine();
            int counter = 0;
            while (line != null)
            {
               String[] lineArray = line.split(",");
               for (int n = 0; n < 3; n++)
               {
                  jobNames[counter][n] = lineArray[n];
               }
               counter ++;
               line = jobNameReader.readLine();
            }
            jobNameReader.close();
            
            
            //put stats into an array
            BufferedReader statReader = new BufferedReader(new FileReader("rawStats.csv"));
            int[][] rawStats = new int[4][5];
            line = statReader.readLine();
            counter = 0;
            while (line != null)
            {
               String[] lineArray = line.split(",");
               for (int n = 0; n < 5; n++)
               {
                  int stat = Integer.parseInt(lineArray[n]);
                  rawStats[counter][n] = stat;// * 16384;
               }
               counter ++;
               line = statReader.readLine();
            }
            statReader.close();
            
            //put jobs into an array
            BufferedReader jobReader = new BufferedReader(new FileReader("jobs.csv"));
            int[][] jobs = new int[160][10];
            line = jobReader.readLine();
            counter = 0;
            while (line != null)
            {
               String[] lineArray = line.split(",");
               for (int n = 0; n < 10; n++)
               {
                  jobs[counter][n] = Integer.parseInt(lineArray[n]);
               }
               counter ++;
               line = jobReader.readLine();
            }
            jobReader.close();
            
            //put skills into an array
            BufferedReader skillReader = new BufferedReader(new FileReader("abilities.csv"));
            int[][] skills = new int[368][3];
            line = skillReader.readLine();
            counter = 0;
            while (line != null)
            {
               String lineArray[] = line.split(",");
               for (int n = 0; n < 3; n++)
               {
                  skills[counter][n] = Integer.parseInt(lineArray[n]);
               }
               counter ++;
               line = skillReader.readLine();
            }
            skillReader.close();
            
            //put skillnames into an array
            BufferedReader skillNameReader = new BufferedReader(new FileReader("skillNames.csv"));
            String[] skillNames = new String[368];
            line = skillNameReader.readLine();
            counter = 0;
            while (line != null)
            {
               skillNames[counter] = line;
               counter ++;
               line = skillNameReader.readLine();
            }
            skillNameReader.close();
            
            int levelCounter = Integer.parseInt(args[0]);
            int levelMax = Integer.parseInt(args[1]);
            int jobCounter = Integer.parseInt(args[2]);
            int jobMax = Integer.parseInt(args[3]);
            int brave = Integer.parseInt(args[7]);
            int casterFaith = Integer.parseInt(args[8]);
            int targetFaith = Integer.parseInt(args[9]);
            int weapon = Integer.parseInt(args[10]);
            int WP = Integer.parseInt(args[11]);
            for (; jobCounter <= jobMax; jobCounter++)
            {
               int jobGender;
               if (Integer.parseInt(jobNames[jobCounter][2]) == 4)
               {//if we're dealing with a generic (besides bard and dancer)...
                  jobGender = Integer.parseInt(args[4]);
               }//use value passed in with program as parameter.
               else
               {//if we're dealing with a bard, dancer, monster, or non-generic...
                  jobGender = Integer.parseInt(jobNames[jobCounter][2]);
               }//use value in text file.
               
               long jobHP = (rawStats[jobGender][0]) * 16384;
               long jobMP = (rawStats[jobGender][1]) * 16384;
               int jobSP = (rawStats[jobGender][2]) * 16384;
               int jobPA = (rawStats[jobGender][3]) * 16384;
               int jobMA = (rawStats[jobGender][4]) * 16384;
               
               HashSet<Integer> zodiacBeasts = new HashSet<Integer>();
               zodiacBeasts.add(60);
               zodiacBeasts.add(62);
               zodiacBeasts.add(64);
               zodiacBeasts.add(65);
               zodiacBeasts.add(67);
               zodiacBeasts.add(69);
               zodiacBeasts.add(73);
               
               //if (zodiacBeasts.contains(jobCounter))
               //{//Comment this out until you know where the * 10 is applied.
                  //jobHP *= 10;
                  //jobMP *= 10;
               //}//Applied to base stat, growth, or multiplier?
               
               int jobHPC = jobs[jobCounter][0];
               int jobHPM = jobs[jobCounter][1];

               int jobMPC = jobs[jobCounter][2];
               int jobMPM = jobs[jobCounter][3];

               int jobSPC = jobs[jobCounter][4];
               int jobSPM = jobs[jobCounter][5];

               int jobPAC = jobs[jobCounter][6];
               int jobPAM = jobs[jobCounter][7];
               
               int jobMAC = jobs[jobCounter][8];
               int jobMAM = jobs[jobCounter][9];
               
               if (jobGender == 0)
               {
                  System.out.println("\nStats ?? -  HP -  MP - SP - PA - MA : Male "  + jobNames[jobCounter][1] + ", " + jobNames[jobCounter][0]);
               }
               else if (jobGender == 1)
               {
                  System.out.println("\nStats ?? -  HP -  MP - SP - PA - MA : Female "  + jobNames[jobCounter][1] + ", " + jobNames[jobCounter][0]);
               }
               else if (jobGender == 2)
               {
                  System.out.println("\nStats ?? -  HP -  MP - SP - PA - MA : Ramza's "  + jobNames[jobCounter][1] + ", " + jobNames[jobCounter][0]);
               }
               else
               {
                  System.out.println("\nStats ?? -  HP -  MP - SP - PA - MA : Monster "  + jobNames[jobCounter][1] + ", " + jobNames[jobCounter][0]);
               }
               if (levelCounter == 1)
               {
                  System.out.print("Level  1 - ");
                  if (((jobHP * jobHPM) / 1638400) < 100)
                  {
                     if (((jobHP * jobHPM) / 1638400) < 10)
                     {//1 digit
                        System.out.print("  " + ((jobHP * jobHPM) / 1638400) + " - ");
                     }
                     else
                     {//2 digits
                        System.out.print(" " + ((jobHP * jobHPM) / 1638400) + " - ");
                     }
                  }
                  else
                  {
                     if (((jobHP * jobHPM) / 1638400) >= 999)
                     {//not needed because impossible to have > 100 stats at level 1
                        System.out.print("999 - ");
                     }
                     else
                     {//3 digits, also not needed for same reasons
                        System.out.print(((jobHP * jobHPM) / 1638400) + " - ");
                     }
                  }
                  if (((jobMP * jobMPM) / 1638400) < 100)
                  {
                     if (((jobMP * jobMPM) / 1638400) < 10)
                     {//1 digit
                        System.out.print("  " + ((jobMP * jobMPM) / 1638400) + " - ");
                     }
                     else
                     {//2 digits
                        System.out.print(" " + ((jobMP * jobMPM) / 1638400) + " - ");
                     }
                  }
                  else
                  {
                     if (((jobMP * jobMPM) / 1638400) >= 999)
                     {//not needed because impossible to have > 100 stats at level 1
                        System.out.print("999 - ");
                     }
                     else
                     {//3 digits, also not needed for same reasons
                        System.out.print(((jobMP * jobMPM) / 1638400) + " - ");
                     }
                  }
                  if (((jobSP * jobSPM) / 1638400) < 10)
                  {
                     System.out.print(" " + ((jobSP * jobSPM) / 1638400) + " - ");
                  }
                  else
                  {
                     System.out.print(((jobSP * jobSPM) / 1638400) + " - ");
                  }
                  if (((jobPA * jobPAM) / 1638400) < 10)
                  {
                     System.out.print(" " + ((jobPA * jobPAM) / 1638400) + " - ");
                  }
                  else
                  {
                     System.out.print(((jobPA * jobPAM) / 1638400) + " - ");
                  }
                  if (((jobMA * jobMAM) / 1638400) < 10)
                  {
                     System.out.print(" " + ((jobMA * jobMAM) / 1638400));
                  }
                  else
                  {
                     System.out.print(((jobMA * jobMAM) / 1638400));
                  }
                  System.out.println();
                  levelCounter++;
               }
               for (int i = 2; i < 100; i++)
               {
                  jobHP = jobHP + (jobHP / (jobHPC + (i - 1)));
                  jobMP = jobMP + (jobMP / (jobMPC + (i - 1)));
                  jobSP = jobSP + (jobSP / (jobSPC + (i - 1)));
                  jobPA = jobPA + (jobPA / (jobPAC + (i - 1)));
                  jobMA = jobMA + (jobMA / (jobMAC + (i - 1)));
                  if (i == levelCounter)
                  {
                     if (i <= 9)
                     {
                        System.out.print("Level  " + i + " - ");
                     }
                     else if (i > 9)
                     {
                        System.out.print("Level " + i + " - ");
                     }
                     if (((jobHP * jobHPM) / 1638400) < 100)
                     {
                        if (((jobHP * jobHPM) / 1638400) < 10)
                        {//1 digit
                           System.out.print("  " + ((jobHP * jobHPM) / 1638400) + " - ");
                        }
                        else
                        {//2 digits
                           System.out.print(" " + ((jobHP * jobHPM) / 1638400) + " - ");
                        }
                     }
                     else
                     {
                        if (((jobHP * jobHPM) / 1638400) >= 999)
                        {//max amount, maybe make room for 4 digits later?
                           System.out.print("999 - ");
                        }
                        else
                        {//3 digits
                           System.out.print(((jobHP * jobHPM) / 1638400) + " - ");
                        }
                     }
                     if (((jobMP * jobMPM) / 1638400) < 100)
                     {
                        if (((jobMP * jobMPM) / 1638400) < 10)
                        {//1 digits
                           System.out.print("  " + ((jobMP * jobMPM) / 1638400) + " - ");
                        }
                        else
                        {//2 digits
                           System.out.print(" " + ((jobMP * jobMPM) / 1638400) + " - ");
                        }
                     }
                     else
                     {
                        if (((jobMP * jobMPM) / 1638400) >= 999)
                        {//max amount, maybe make room for 4 digits later?
                           System.out.print("999 - ");
                        }
                        else
                        {//3 digits
                           System.out.print(((jobMP * jobMPM) / 1638400) + " - ");
                        }
                     }
                     if (((jobSP * jobSPM) / 1638400) < 10)
                     {
                        System.out.print(" " + ((jobSP * jobSPM) / 1638400) + " - ");
                     }
                     else
                     {
                        System.out.print(((jobSP * jobSPM) / 1638400) + " - ");
                     }
                     if (((jobPA * jobPAM) / 1638400) < 10)
                     {
                        System.out.print(" " + ((jobPA * jobPAM) / 1638400) + " - ");
                     }
                     else
                     {
                        System.out.print(((jobPA * jobPAM) / 1638400) + " - ");
                     }
                     if (((jobMA * jobMAM) / 1638400) < 10)
                     {
                        System.out.print(" " + ((jobMA * jobMAM) / 1638400));
                     }
                     else
                     {
                        System.out.print(((jobMA * jobMAM) / 1638400));
                     }
                     System.out.println();
                     //work area is here
                     int skillCounter = Integer.parseInt(args[5]);
                     int skillMax = Integer.parseInt(args[6]);
                     
                     while (skillCounter < skillMax)
                     {
                        int formula = skills[skillCounter][0];
                        int xVal = skills[skillCounter][1];
                        int yVal = skills[skillCounter][2];
                        int dmg = 0;
                        int heal = 0;
                        int hit = 0;
                        String formulaName = null;
                        boolean dmgBool = false;//bools needed because dmg/heal/hit may be =<0
                        boolean healBool = false;
                        boolean hitBool = false;
                        int tempPA = ((jobPA * jobPAM) / 1638400);
                        int tempMA = ((jobMA * jobMAM) / 1638400);
                        int tempSP = ((jobSP * jobSPM) / 1638400);
                        
                        switch (formula)
                        {//cases that don't depend on stats?
                         //Nonetheless, x and y vals are included in parameters...
                         //nah, remove anything not based on pa, ma, or sp
                           case 0:  formulaName = "Dummy: 0 - " ;
                                    break;
                           case 1:  switch (weapon)
                                    {
                                       case 0: dmg = WP * tempPA;
                                       case 1: dmg = WP * tempMA;
                                       case 2: dmg = WP * WP;
                                       case 3: dmg = WP * tempPA * brave / 100;
                                       case 4: dmg = WP * ((tempPA + tempSP) / 2);
                                       case 5: dmg = WP * ((tempPA + tempMA) / 2);
                                       case 6: dmg = tempPA * WP / 2;
                                    }
                                    formulaName = "Dmg_(Weapon): 1 - ";
                                    dmgBool = true;
                                    break;
                           case 2:  switch (weapon)
                                    {
                                       case 0: dmg = WP * tempPA;
                                       case 1: dmg = WP * tempMA;
                                       case 2: dmg = WP * WP;
                                       case 3: dmg = WP * tempPA * brave / 100;
                                       case 4: dmg = WP * ((tempPA + tempSP) / 2);
                                       case 5: dmg = WP * ((tempPA + tempMA) / 2);
                                       case 6: dmg = tempPA * WP / 2;
                                    }
                                    formulaName = "Dmg_(Weapon): 2 - ";
                                    dmgBool = true;
                                    break;
                           case 3:  dmg = WP * WP;
                                    formulaName = "Dmg_(WP^2): 3 - ";
                                    dmgBool = true;
                                    break;
                           case 4:  dmg = 14 * WP * casterFaith / 100 * targetFaith / 100;
                                    formulaName = "Magic Gun: 4 - ";
                                    dmgBool = true;//14 is the average power of the 3 listed spells
                                    break;//not sure if it relies on x/y values of those spells
                           case 5:  switch (weapon)
                                    {
                                       case 0: dmg = WP * tempPA;
                                       case 1: dmg = WP * tempMA;
                                       case 2: dmg = WP * WP;
                                       case 3: dmg = WP * tempPA * brave / 100;
                                       case 4: dmg = WP * ((tempPA + tempSP) / 2);
                                       case 5: dmg = WP * ((tempPA + tempMA) / 2);
                                       case 6: dmg = tempPA * WP / 2;
                                    }
                                    formulaName = "Dmg_(Weapon): 5 - ";
                                    dmgBool = true;
                                    break;
                           case 6:  switch (weapon)
                                    {
                                       case 0: dmg = WP * tempPA;
                                       case 1: dmg = WP * tempMA;
                                       case 2: dmg = WP * WP;
                                       case 3: dmg = WP * tempPA * brave / 100;
                                       case 4: dmg = WP * ((tempPA + tempSP) / 2);
                                       case 5: dmg = WP * ((tempPA + tempMA) / 2);
                                       case 6: dmg = tempPA * WP / 2;
                                    }
                                    formulaName = "AbsHP_(Weapon) - ";
                                    dmgBool = true;
                                    break;
                           case 7:  switch (weapon)
                                    {
                                       case 0: heal = WP * tempPA;
                                       case 1: heal = WP * tempMA;
                                       case 2: heal = WP * WP;
                                       case 3: heal = WP * tempPA * brave / 100;
                                       case 4: heal = WP * ((tempPA + tempSP) / 2);
                                       case 5: heal = WP * ((tempPA + tempMA) / 2);
                                       case 6: heal = tempPA * WP / 2;
                                    }
                                    formulaName = "Heal_(Weapon) - ";
                                    healBool = true;
                                    break;
                           case 8:  dmg = tempMA * yVal * casterFaith / 100 * targetFaith / 100;
                                    formulaName = "Dmg_F(MA * Y) - ";
                                    dmgBool = true;
                                    break;
                           case 9:  hit = (tempMA + xVal) * casterFaith / 100 * targetFaith / 100;
                                    formulaName = "Dmg_(Y / 100)% Hit_F(MA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 10: hit = (tempMA + xVal) * casterFaith / 100 * targetFaith / 100;
                                    formulaName = "Hit_F(MA + X)% - ";
                                    hitBool = true;
                                    break;
                           case 11: hit = (tempMA + xVal) * casterFaith / 100 * targetFaith / 100;
                                    formulaName = "Hit_F(MA + X) - ";
                                    hitBool = true;
                                    break;
                           case 12: heal = tempMA * yVal * casterFaith / 100 * targetFaith / 100;
                                    formulaName = "Heal_F(MA * Y) - ";
                                    healBool = true;
                                    break;
                           case 13: hit = (tempMA + xVal) * casterFaith / 100 * targetFaith / 100;
                                    formulaName = "Heal_(Y)% Hit_F(MA + X) - ";
                                    hitBool = true;
                                    break;
                           case 14: hit = (tempMA + xVal) * casterFaith / 100 * targetFaith / 100;
                                    formulaName = "Dmg_(Y)% Hit_F(MA + X) - ";
                                    hitBool = true;
                                    break;
                           case 15: hit = (tempMA + xVal) * casterFaith / 100 * targetFaith / 100;
                                    formulaName = "AbsMP_(Y)% Hit_F(MA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 16: hit = (tempMA + xVal) * casterFaith / 100 * targetFaith / 100;
                                    formulaName = "AbsHP_(Y)% Hit_F(MA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 17: formulaName = "Dummy 17 - ";
                                    break;
                           case 18: hit = (tempMA + xVal) * casterFaith / 100 * targetFaith / 100;
                                    formulaName = "Set_Quick Hit_F(MA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 19: formulaName = "Dummy 19 - ";
                                    break;
                           case 20: hit = (tempMA + xVal) * casterFaith / 100 * targetFaith / 100;
                                    formulaName = "Set_Golem Hit_CasF/100*(MA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 21: hit = (tempMA + xVal) * casterFaith / 100 * targetFaith / 100;
                                    formulaName = "Set_CT00 Hit_F(MA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 22: hit = (tempMA + xVal) * casterFaith / 100 * targetFaith / 100;
                                    formulaName = "DmgMP_(TarCurMP) Hit_F(MA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 23: hit = (tempMA + xVal) * casterFaith / 100 * targetFaith / 100;
                                    formulaName = "Dmg_(TarCurHP-1) Hit_F(MA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 24: formulaName = "Dummy 24 - ";
                                    break;
                           case 25: formulaName = "Dummy 25 - ";
                                    break;
                           case 26: hit = (tempMA + xVal) * casterFaith / 100 * targetFaith / 100;
                                    formulaName = "Hit_F(MA+Y)% // -PA/MA/SP_(X) - ";
                                    hitBool = true;
                                    break;
                           case 27: hit = (tempMA + xVal) * casterFaith / 100 * targetFaith / 100;
                                    formulaName = "DmgMP_(MA+Y)% Hit_F(X)% - ";
                                    hitBool = true;
                                    break;
                           case 28: formulaName = "Hit_(X)% - IRRELEVANT";
                                    break;
                           case 29: formulaName = "Hit_(X)% - IRRELEVANT";
                                    break;
                           case 30: dmg = (tempMA + yVal) * tempMA / 2;
                                    formulaName = "Dmg_((MA+Y)*MA/2) #Hit(Rdm(1,X)) - ";
                                    dmgBool = true;
                                    break;//correct
                           case 31: dmg = (100 - casterFaith) * (100 - targetFaith) * (tempMA + yVal) * tempMA / 20000;
                                    formulaName = "Dmg ((100-CasF)*(100-TarF)*(MA+Y)*MA/2) #Hit(Rdm(1,X)) - ";
                                    dmgBool = true;
                                    break;
                           case 32: dmg = tempMA * yVal;
                                    formulaName = "Dmg_(MA*Y) - ";
                                    dmgBool = true;
                                    break;
                           case 33: dmg = tempMA * yVal;
                                    formulaName = "DmgMP_(MA*Y) - ";
                                    dmgBool = true;
                                    break;
                           case 34: formulaName = "Hit(100)% - IRRELEVANT";
                                    break;
                           case 35: heal = tempMA * yVal;
                                    formulaName = "Heal_(MA*Y) - ";
                                    healBool = true;
                                    break;//correct
                           case 36: dmg = (tempPA + yVal) / 2 * tempMA;
                                    formulaName = "Dmg_((PA+Y)/2*MA) - ";
                                    dmgBool = true;
                                    break;
                           case 37: hit = tempPA + WP + xVal;
                                    formulaName = "Equipped: Break Hit_(PA+WP+X)% - ";
                                    hitBool = true;
                                    break;
                           case 38: hit = tempSP + xVal;
                                    formulaName = "Equipped: Steal Hit_(SP+X)% - ";
                                    hitBool = true;
                                    break;
                           case 39: dmg = levelCounter * tempSP;
                                    hit = tempSP + xVal;
                                    formulaName = "StealGil_(CasLVL*SP) Hit_(SP+X)% - ";
                                    dmgBool = true;
                                    hitBool = true;
                                    break;
                           case 40: dmg = tempSP + yVal;
                                    hit = tempSP + xVal;
                                    formulaName = "StealExp_(Lowest of TarCurExp & SP+Y) Hit_(SP+X)% - ";
                                    dmgBool = true;
                                    hitBool = true;
                                    break;
                           case 41: hit = tempMA + xVal;
                                    formulaName = "OppositeSex: Hit_(MA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 42: hit = tempMA + xVal;
                                    formulaName = "Hit_(MA+X)% AffectBraveOrFaith(Y) - ";
                                    hitBool = true;
                                    break;
                           case 43: hit = tempPA + yVal;
                                    dmg = xVal;
                                    formulaName = "Hit_(PA+X)% -PA/MA/SP_(X) - ";
                                    hitBool = true;
                                    dmgBool = true;
                                    break;//correct
                           case 44: hit = tempPA + yVal;
                                    formulaName = "DmgMP_(X)% Hit_(PA+Y)% - ";
                                    hitBool = true;
                                    break;
                           case 45: dmg = tempPA * (WP + yVal);
                                    formulaName = "Dmg_(PA*(WP+Y)) 100% Status - ";
                                    dmgBool = true;
                                    break;
                           case 46: dmg = tempPA * WP;
                                    formulaName = "Equipped:Break Dmg_(PA*WP) - ";
                                    dmgBool = true;
                                    break;
                           case 47: dmg = tempPA * WP;
                                    formulaName = "AbsMP_(PA*WP) - ";
                                    dmgBool = true;
                                    break;
                           case 48: dmg = tempPA * WP;
                                    formulaName = "AbsHP_(PA*WP) - ";
                                    dmgBool = true;
                                    break;
                           case 49: dmg = (tempPA + yVal) / 2 * tempPA;
                                    formulaName = "Dmg_((PA+Y)/2*PA) - ";
                                    dmgBool = true;
                                    break;
                           case 50: dmg = xVal / 2 * ((tempPA * 3) + yVal);
                                    formulaName = "Dmg_(Rdm(1…X)*(PA*3+Y)) - ";
                                    dmgBool = true;
                                    break;
                           case 51: hit = tempPA + xVal;
                                    formulaName = "Hit_(PA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 52: heal = tempPA * yVal;
                                    formulaName = "Heal_(PA*Y) HealMP_(PA*Y/2) - ";
                                    healBool = true;
                                    break;
                           case 53: hit = tempPA + xVal;
                                    formulaName = "Heal_(Y)% Hit_(PA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 54: formulaName = "+PA_(Y) - IRRELEVANT";
                                    break; 
                           case 55: dmg = yVal / 2 * tempPA;
                                    formulaName = "Dmg_(Rdm(1…Y)*PA) - ";
                                    dmgBool = true;
                                    break;
                           case 56: formulaName = "(100%) - IRRELEVANT";
                                    break;
                           case 57: formulaName = "+SP_(Y) - IRRELEVANT";
                                    break;
                           case 58: formulaName = "+Brave_(Y) - IRRELEVANT";
                                    break;
                           case 59: formulaName = "+Brave_(X) +PA/MA/SP_(Y) - IRRELEVANT";
                                    break;
                           case 60: formulaName = "Heal_(CasMaxHP*2/5) DmgCas_(CasMaxHP/5) - IRRELEVANT";
                                    break;
                           case 61: hit = tempMA + xVal;
                                    formulaName = "Hit_(MA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 62: formulaName = "Dmg_(TarMaxHP-1) - IRRELEVANT";
                                    break;
                           case 63: hit = tempSP + xVal;
                                    formulaName = "Hit_(SP+X)% - ";
                                    hitBool = true;
                                    break;
                           case 64: hit = tempSP + xVal;
                                    formulaName = "Undead: Hit_(SP+X)% - ";
                                    hitBool = true;
                                    break;
                           case 65: hit = tempMA + xVal;
                                    formulaName = "Hit_(MA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 66: dmg = tempPA * yVal;
                                    formulaName = "Dmg_(PA*Y) DmgCas_(PA*Y/X) - ";
                                    dmgBool = true;
                                    break;
                           case 67: formulaName = "Dmg_(CasMaxHP-CasCurHP) - IRRELEVANT";
                                    break;
                           case 68: formulaName = "Dmg_(TarCurMP) - IRRELEVANT";
                                    break;
                           case 69: formulaName = "Dmg_(TarMaxHP-TarCurHP) - IRRELEVANT";
                                    break;
                           case 70: formulaName = "Dummy 70 - ";
                                    break;
                           case 71: formulaName = "AbspHP_(Y)% 100% Status - IRRELEVANT";
                                    break;
                           case 72: formulaName = "Heal_(Z*10) - IRRELEVANT";
                                    break;
                           case 73: formulaName = "HealMP_(Z*10) - IRRELEVANT";
                                    break;
                           case 74: formulaName = "HealHP/MP_(All) - IRRELEVANT";
                                    break;
                           case 75: formulaName = "Heal_(Rnd(1...9)) 100% Status - IRRELEVANT";
                                    break;
                           case 76: heal = tempMA * yVal;
                                    formulaName = "Heal_(MA*Y) - ";
                                    healBool = true;
                                    break;
                           case 77: hit = tempMA + xVal;
                                    formulaName = "AbsHP_(Y)% Hit_(MA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 78: dmg = tempMA * yVal;
                                    formulaName = "Dmg_(MA*Y) - ";
                                    dmgBool = true;
                                    break;
                           case 79: hit = tempPA + xVal;
                                    formulaName = "Dmg_(CasMaxHP-CasCurHP) Hit_(PA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 80: hit = tempMA + xVal;
                                    formulaName = "Hit_(MA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 81: hit = tempMA + xVal;
                                    formulaName = "Hit_(MA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 82: formulaName = "Dmg_(CasMaxHP-CasCurHP) - IRRELEVANT";
                                    break;
                           case 83: hit = tempMA + xVal;
                                    formulaName = "Dmg_(X)% Hit_(MA+X)% - ";
                                    hitBool = true;
                                    break;//everything above this point is fine.
                           case 84: heal = tempMA * yVal;
                                    formulaName = "HealMP_(MA*Y) - ";
                                    healBool = true;
                                    break;
                           case 85: hit = tempMA + xVal;
                                    formulaName = "-PA(Y) Hit_(MA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 86: hit = tempMA + xVal;
                                    formulaName = "-MA(Y) Hit_(MA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 87: formulaName = "+Lvl(1) - IRRELEVANT";
                                    break;
                           case 88: hit = tempMA + xVal;
                                    formulaName = "Generic: Set_Morbol: Hit(MA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 89: hit = tempMA + xVal;
                                    formulaName = "-Lvl(1) Hit_(MA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 90: formulaName = "Dragon: Hit(100)% - IRRELEVANT";
                                    break;
                           case 91: formulaName = "Dragon: Heal(Y)% - IRRELEVANT";
                                    break;
                           case 92: formulaName = "Dragon: +Brave(X) - IRRELEVANT";
                                    break;
                           case 93: formulaName = "Dragon: Set_Quick - IRRELEVANT";
                                    break;
                           case 94: dmg = ((tempMA + yVal) / 2 * tempMA);
                                    formulaName = "Dmg_((MA+Y)/2*MA) #Hit_(X+1) 6.25% Status - ";
                                    dmgBool = true;
                                    break;
                           case 95: dmg = ((tempMA + yVal) / 2 * tempMA);
                                    formulaName = "Dmg_((MA+Y)/2*MA) - ";
                                    dmgBool = true;
                                    break;
                           case 96: dmg = ((tempMA + yVal) / 2 * tempMA);
                                    formulaName = "Dmg_((MA+Y)/2*MA) 6.25% Status - ";
                                    dmgBool = true;
                                    break;
                           case 97: hit = (tempMA + xVal) * casterFaith / 100 * targetFaith / 100;
                                    formulaName = "-Brave_(Y) Hit_F(MA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 98: hit = tempMA + xVal;
                                    formulaName = "-Brave_(Y) Hit_(MA+X)% - ";
                                    hitBool = true;
                                    break;
                           case 99: dmg = tempSP * WP;
                                    formulaName = "Dmg_(SP*WP) - ";
                                    dmgBool = true;
                                    break;
                           case 100: dmg = tempPA * WP;
                                    formulaName = "Dmg_(PA*WP) - ";
                                    dmgBool = true;
                                    break;
                                    
                        }
                        String currentSkillName = skillNames[skillCounter];
                        while (currentSkillName.length() < 16)
                        {
                           currentSkillName += ".";
                        }
                        System.out.print("  " + currentSkillName + " - ");

                        if (dmgBool)
                        {
                           if (dmg < 10)
                           {
                              System.out.print("Dmg :   " + dmg + " - ");
                           }
                           else if (dmg < 100)
                           {
                              System.out.print("Dmg :  " + dmg + " - ");
                           }
                           else
                           {
                              System.out.print("Dmg : " + dmg + " - ");
                           }
                        }
                        else
                        {
                           System.out.print("Dmg :     - ");
                        }
                        if (healBool)
                        {
                           if (heal < 10)
                           {
                              System.out.print("Heal:   " + heal + " - ");
                           }
                           else if (heal < 100)
                           {
                              System.out.print("Heal:  " + heal + " - ");
                           }
                           else
                           {
                              System.out.print("Heal: " + heal + " - ");
                           }
                        }
                        else
                        {
                           System.out.print("Heal:     - ");
                        }
                        if (hitBool)
                        {
                           if (hit < 10)
                           {
                              System.out.print("Hit :   " + hit + " - ");
                           }
                           else if (hit < 100)
                           {
                              System.out.print("Hit :  " + hit + " - ");
                           }
                           else
                           {
                              System.out.print("Hit : " + hit + " - ");
                           }
                        }
                        else
                        {
                           System.out.print("Hit :     - ");
                        }
                        System.out.println(formulaName);
                                                
                        skillCounter++;
                     }
                     
                     if (levelCounter < levelMax)
                     {
                        levelCounter++;
                     }
                  }
               }
               levelCounter = Integer.parseInt(args[0]);
            }
         }
      }
      catch (Exception e)
      {
         System.out.println(e);
         e.printStackTrace();
         System.out.println("\n\n*.csv files must be in the same directory as MakeCSV.class\n\n");
      }
   }
}
